//==============================================================================
//
// c_corvus3_anim.c
//
// Heretic II
// Copyright 1998 Raven Software
//
//==============================================================================

#include "g_local.h"

#pragma hdrstop("g_local.pch")
// PRECOMPILED HEADER ABOVE
// WARNING:  DO NOT CHANGE THE ABOVE HEADERS OR THE PRECOMPILED STUFF WILL BREAK!  
// ADD ANY ADDITIONAL FILES BELOW

#include "c_corvus3_anim.h"
#include "c_corvus3.h"

#include "c_ai.h"

void corvus3_teleporteffect (edict_t *self);
void corvus3_teleportsmalleffect (edict_t *self);
void corvus3_visible (edict_t *self);
void corvus3_invisible (edict_t *self);

/************************************************************************
/************************************************************************
// 
//  Cinematic Frames
// 
/************************************************************************
/*************************************************************************/

/*----------------------------------------------------------------------
  Corvus
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_action1 [] =
{
	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_calie1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
};

animmove_t corvus3_move_c_action1 = {30, corvus3_frames_c_action1, ai_c_cycleend};


/*----------------------------------------------------------------------
  Corvus
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_action2 [] =
{
	FRAME_calie12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_calie21,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie22,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie23,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie24,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie25,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie26,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie27,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie28,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie29,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie30,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie31,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie32,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie33,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie34,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie35,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie36,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie37,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie38,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie39,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie40,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie41,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie42,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie43,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie44,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie45,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie46,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie47,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
};
animmove_t corvus3_move_c_action2 = {35, corvus3_frames_c_action2, ai_c_cycleend};

/*----------------------------------------------------------------------
  Corvus
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_action3 [] =
{
	FRAME_calie48,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie49,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie50,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie51,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie52,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie53,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_calie54,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_caidle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_caidle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_caidle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_caidle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_caidle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_caidle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_caidle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_caidle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
//	FRAME_caidle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
//	FRAME_caidle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
//	FRAME_caidle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
//	FRAME_caidle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
//	FRAME_caidle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
//	FRAME_caidle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
//	FRAME_caidle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
//	FRAME_caidle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
//	FRAME_caidle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

//	FRAME_caidle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
//	FRAME_caidle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
//	FRAME_caidle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
//	FRAME_caidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
//	FRAME_caidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
//	FRAME_caidle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
//	FRAME_caidle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

};
animmove_t corvus3_move_c_action3 = {151, corvus3_frames_c_action3, ai_c_cycleend};

/*----------------------------------------------------------------------
  Corvus
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_action4 [] =
{
	FRAME_catalk1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_catalk1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_catalk1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_catalk1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_catalk7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_caidle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_caidle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cratran5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cratran4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cratran3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cratran2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cratran1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle21,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle22,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle23,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle24,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle21,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle22,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle23,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle24,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle21,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle22,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle23,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle24,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle21,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle22,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle23,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle24,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle21,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle22,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle23,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle24,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle21,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle22,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle23,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle24,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

};
animmove_t corvus3_move_c_action4 = {216, corvus3_frames_c_action4, ai_c_cycleend};

/*----------------------------------------------------------------------
  Corvus
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_action5 [] =
{
	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle21,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle22,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle23,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle24,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle21,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle22,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle23,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle24,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle21,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle22,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle23,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle24,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle21,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle22,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle23,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle24,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle21,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle22,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle23,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle24,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle21,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle22,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle23,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle24,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle21,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle22,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle23,  ai_c_move, 0, 0, 0, NULL, 0, NULL,


	FRAME_cwhat1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat21,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat22,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat23,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat24,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat25,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat26,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat27,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat28,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat29,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

};
animmove_t corvus3_move_c_action5 = {196, corvus3_frames_c_action5, ai_c_cycleend};

/*----------------------------------------------------------------------
  Corvus
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_action6 [] =
{
	FRAME_cwhat29,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat30,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat31,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat32,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat33,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat34,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat35,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat36,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwhat37,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_csidle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

};
animmove_t corvus3_move_c_action6 = {12, corvus3_frames_c_action6, ai_c_cycleend};

/*----------------------------------------------------------------------
  Corvus
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_action7 [] =
{
	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
};
animmove_t corvus3_move_c_action7 = {11, corvus3_frames_c_action7, ai_c_cycleend};

/*----------------------------------------------------------------------
  Corvus
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_action8 [] =
{
	FRAME_crtalk1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk21,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk22,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk23,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk24,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_crtalk1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk21,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk22,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk23,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk24,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_crtalk1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
};
animmove_t corvus3_move_c_action8 = {65, corvus3_frames_c_action8, ai_c_cycleend};

/*----------------------------------------------------------------------
  Corvus
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_action9 [] =
{
	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
};
animmove_t corvus3_move_c_action9 = {102, corvus3_frames_c_action9, ai_c_cycleend};

/*----------------------------------------------------------------------
  Corvus
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_action10 [] =
{
	FRAME_crtalk1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk21,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk22,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk23,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk24,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_crtalk1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

};
animmove_t corvus3_move_c_action10 = {40, corvus3_frames_c_action10, ai_c_cycleend};

/*----------------------------------------------------------------------
  Corvus
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_action11 [] =
{
	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

};
animmove_t corvus3_move_c_action11 = {179, corvus3_frames_c_action11, ai_c_cycleend};

/*----------------------------------------------------------------------
  Corvus
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_action12 [] =
{
	FRAME_crtalk1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk21,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk22,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk23,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk24,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_crtalk1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk21,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk22,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk23,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk24,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_crtalk1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_crtalk5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

};
animmove_t corvus3_move_c_action12 = {53, corvus3_frames_c_action12, ai_c_cycleend};

/*----------------------------------------------------------------------
  Corvus
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_action13 [] =
{
	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cridle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cridle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
};
animmove_t corvus3_move_c_action13 = {58, corvus3_frames_c_action13, ai_c_cycleend};

/*----------------------------------------------------------------------
  Corvus
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_action14 [] =
{
	FRAME_cido2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cido3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cido4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cido5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cido7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cido8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cido9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cido10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cido12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cido13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cido14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cido15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cido17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
};
animmove_t corvus3_move_c_action14 = {13, corvus3_frames_c_action14, ai_c_cycleend};

/*----------------------------------------------------------------------
  Corvus
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_action15 [] =
{
	FRAME_csidle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_csidle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_csidle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_csidle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_csidle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_csidle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,


	FRAME_csidle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_csidle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

};
animmove_t corvus3_move_c_action15 = {142, corvus3_frames_c_action15, ai_c_cycleend};

/*----------------------------------------------------------------------
  Corvus
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_action16 [] =
{
	FRAME_cstalk1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cstalk1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cstalk1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_cstalk1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cstalk18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_csidle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_csidle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle12,  ai_c_move, 0, 0, 0, NULL, 0, corvus3_teleportsmalleffect,
	FRAME_csidle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle18,  ai_c_move, 0, 0, 0, NULL, 0, corvus3_teleportsmalleffect,
	FRAME_csidle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,

	FRAME_csidle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle4,  ai_c_move, 0, 0, 0, NULL, 0, corvus3_teleportsmalleffect,
	FRAME_csidle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle10,  ai_c_move, 0, 0, 0, NULL, 0, corvus3_teleportsmalleffect,
	FRAME_csidle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle16,  ai_c_move, 0, 0, 0, NULL, 0, corvus3_teleportsmalleffect,
	FRAME_csidle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle20,  ai_c_move, 0, 0, 0, NULL, 0, corvus3_teleportsmalleffect,


	FRAME_csidle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle4,  ai_c_move, 0, 0, 0, NULL, 0, corvus3_teleportsmalleffect,
	FRAME_csidle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle8,  ai_c_move, 0, 0, 0, NULL, 0, corvus3_teleportsmalleffect,
	FRAME_csidle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_csidle10,  ai_c_move, 0, 0, 0, NULL, 0, corvus3_teleporteffect,
	FRAME_csidle11,  ai_c_move, 0, 0, 0, NULL, 0, corvus3_invisible,

};
animmove_t corvus3_move_c_action16 = {149, corvus3_frames_c_action16, ai_c_cycleend};


/*----------------------------------------------------------------------
  Corvus
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_action17 [] =
{
	FRAME_cpidle1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cpidle2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cpidle3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cpidle4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cpidle5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cpidle6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cpidle7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cpidle8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cpidle9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cpidle10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cpidle11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cpidle12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cpidle13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cpidle14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cpidle15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cpidle16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cpidle17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cpidle18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cpidle19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cpidle20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
};
animmove_t corvus3_move_c_action17 = {20, corvus3_frames_c_action17, ai_c_cycleend};



/*----------------------------------------------------------------------
  Corvus
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_action18 [] =
{
	FRAME_cwish1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwish2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwish3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwish4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwish5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwish6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwish7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwish8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwish9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwish10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cwish11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
};
animmove_t corvus3_move_c_action18 = {11, corvus3_frames_c_action18, ai_c_cycleend};

/*----------------------------------------------------------------------
  Corvus
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_action19 [] =
{
	FRAME_ciwill1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill21,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill22,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill23,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill24,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill25,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill26,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill27,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill28,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill29,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill30,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill31,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill32,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill33,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill34,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill35,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill36,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill37,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill38,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill39,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill40,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill41,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill42,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill43,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill44,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill45,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill46,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill47,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill48,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill49,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill50,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill51,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill52,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill53,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill54,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill55,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill56,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill57,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill58,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill59,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill60,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill61,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill62,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill63,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_ciwill64,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
};
animmove_t corvus3_move_c_action19 = {64, corvus3_frames_c_action19, ai_c_cycleend};


/*----------------------------------------------------------------------
  Corvus
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_action20 [] =
{
	FRAME_cyour1,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour2,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour3,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour4,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour5,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour6,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour7,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour8,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour9,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour10,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour11,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour12,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour13,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour14,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour15,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour16,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour17,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour18,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour19,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour20,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour21,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour22,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour23,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour24,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour25,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour26,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour27,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour28,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour29,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour30,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour31,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour32,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour33,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour34,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour35,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour36,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour37,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour38,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour39,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour40,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour41,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour42,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour43,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour44,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour45,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour46,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour47,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_cyour48,  ai_c_move, 0, 0, 0, NULL, 0, NULL,
};
animmove_t corvus3_move_c_action20 = {48, corvus3_frames_c_action20, ai_c_cycleend};

/*----------------------------------------------------------------------
  Corvus Standing - 
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_idle1 [] =
{
	FRAME_Breath1, ai_c_move, 0, 0, 0,  NULL, 0, NULL, 
	FRAME_Breath2, ai_c_move, 0, 0, 0,  NULL, 0, NULL, 
	FRAME_Breath3, ai_c_move, 0, 0, 0,  NULL, 0, NULL, 
	FRAME_Breath4, ai_c_move, 0, 0, 0,  NULL, 0, NULL, 
	FRAME_Breath5, ai_c_move, 0, 0, 0,  NULL, 0, NULL, 
	FRAME_Breath6, ai_c_move, 0, 0, 0,  NULL, 0, NULL, 
	FRAME_Breath7, ai_c_move, 0, 0, 0,  NULL, 0, NULL, 
	FRAME_Breath8, ai_c_move, 0, 0, 0,  NULL, 0, NULL, 
	FRAME_Breath9, ai_c_move, 0, 0, 0,  NULL, 0, NULL, 
	FRAME_Breath10, ai_c_move, 0, 0, 0,  NULL, 0, NULL, 
	FRAME_Breath11, ai_c_move, 0, 0, 0,  NULL, 0, NULL, 
	FRAME_Breath12, ai_c_move, 0, 0, 0,  NULL, 0, NULL, 
	FRAME_Breath13, ai_c_move, 0, 0, 0,  NULL, 0, NULL, 
	FRAME_Breath14, ai_c_move, 0, 0, 0,  NULL, 0, NULL, 
	FRAME_Breath15, ai_c_move, 0, 0, 0,  NULL, 0, NULL, 
	FRAME_Breath16, ai_c_move, 0, 0, 0,  NULL, 0, NULL, 
	FRAME_Breath17, ai_c_move, 0, 0, 0,  NULL, 0, NULL, 
	FRAME_Breath18, ai_c_move, 0, 0, 0,  NULL, 0, NULL, 
	FRAME_Breath19, ai_c_move, 0, 0, 0,  NULL, 0, NULL, 
	FRAME_Breath20, ai_c_move, 0, 0, 0,  NULL, 0, NULL, 
	FRAME_Breath21, ai_c_move, 0, 0, 0,  NULL, 0, NULL, 
	FRAME_Breath22, ai_c_move, 0, 0, 0,  NULL, 0, NULL, 
	FRAME_Breath23, ai_c_move, 0, 0, 0,  NULL, 0, NULL 

};

animmove_t corvus3_move_c_idle1 = {23, corvus3_frames_c_idle1, ai_c_cycleend};



/*----------------------------------------------------------------------
  Corvus 
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_idle2 [] =
{
	FRAME_stance1, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance2, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance3, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance4, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance5, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance6, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance7, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance8, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance9, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance10, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance11, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance12, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance13, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance14, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance15, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance16, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance17, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance18, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance19, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance20, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance21, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance22, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance23, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance24, ai_c_move, 4, 0, 0, NULL, 0, NULL,
};

animmove_t corvus3_move_c_idle2 = {24, corvus3_frames_c_idle2, ai_c_cycleend};


/*----------------------------------------------------------------------
  Corvus 
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_idle3 [] =
{
	FRAME_stance1, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance2, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance3, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance4, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance5, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance6, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance7, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance8, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance9, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance10, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance11, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance12, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance13, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance14, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance15, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance16, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance17, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance18, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance19, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance20, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance21, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance22, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance23, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_stance24, ai_c_move, 4, 0, 0, NULL, 0, NULL,
};

animmove_t corvus3_move_c_idle3 = {24, corvus3_frames_c_idle3, ai_c_cycleend};

/*----------------------------------------------------------------------
  Corvus - starting his pivot to the left
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_pivotleftgo [] =
{	
	FRAME_Lpivot1, ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_Lpivot2, ai_c_move, 0, 0, 0, NULL, 0, NULL,
};
animmove_t corvus3_move_c_pivotleftgo = {2, corvus3_frames_c_pivotleftgo, ai_c_cycleend};

animframe_t corvus3_frames_c_pivotleft [] =
{	
	FRAME_Lpivot3, ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_Lpivot4, ai_c_move, 0, 0, 0, NULL, 0, NULL,
};
animmove_t corvus3_move_c_pivotleft = {2, corvus3_frames_c_pivotleft, ai_c_cycleend};


animframe_t corvus3_frames_c_pivotleftstop [] =
{	
	FRAME_Lpivot4, ai_c_move, 0, 0, 0, NULL, 0, NULL,
};
animmove_t corvus3_move_c_pivotleftstop = {1, corvus3_frames_c_pivotleftstop, ai_c_cycleend};



/*----------------------------------------------------------------------
  Corvus - starting his pivot to the right
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_pivotrightgo [] =
{	
	FRAME_Lpivot4, ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_Lpivot3, ai_c_move, 0, 0, 0, NULL, 0, NULL,
};
animmove_t corvus3_move_c_pivotrightgo = {2, corvus3_frames_c_pivotrightgo, ai_c_cycleend};

animframe_t corvus3_frames_c_pivotright [] =
{	
	FRAME_Lpivot2, ai_c_move, 0, 0, 0, NULL, 0, NULL,
	FRAME_Lpivot1, ai_c_move, 0, 0, 0, NULL, 0, NULL,
};
animmove_t corvus3_move_c_pivotright = {2, corvus3_frames_c_pivotright, ai_c_cycleend};


animframe_t corvus3_frames_c_pivotrightstop [] =
{	
	FRAME_Lpivot1, NULL, 0, 0, 0, NULL, 0, NULL,
};
animmove_t corvus3_move_c_pivotrightstop = {1, corvus3_frames_c_pivotrightstop, ai_c_cycleend};


/*----------------------------------------------------------------------
  Corvus 
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_walk1 [] =
{
	FRAME_jog1, ai_c_move, 10, 0, 0, NULL, 0, NULL,
	FRAME_jog2, ai_c_move, 16, 0, 0, NULL, 0, NULL,
	FRAME_jog3, ai_c_move, 15, 0, 0, NULL, 0, NULL,
	FRAME_jog4, ai_c_move, 16, 0, 0, NULL, 0, NULL,
	FRAME_jog5, ai_c_move, 17, 0, 0, NULL, 0, NULL,
	FRAME_jog6, ai_c_move, 16, 0, 0, NULL, 0, NULL,
	FRAME_jog7, ai_c_move, 15, 0, 0, NULL, 0, NULL,
	FRAME_jog8, ai_c_move, 16, 0, 0, NULL, 0, NULL,
};
animmove_t corvus3_move_c_walk1 = {8, corvus3_frames_c_walk1, ai_c_cycleend};

/*----------------------------------------------------------------------
  Corvus 
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_walk2 [] =
{
	FRAME_cinewalk1, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk2, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk3, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk4, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk5, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk6, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk7, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk8, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk9, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk10, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk11, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk12, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk13, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk14, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk15, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk16, ai_c_move, 4, 0, 0, NULL, 0, NULL,
};

animmove_t corvus3_move_c_walk2 = {16, corvus3_frames_c_walk2, ai_c_cycleend};

/*----------------------------------------------------------------------
  Corvus 
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_walk3 [] =
{
	FRAME_cinewalk1, ai_c_move, 4, 0, 0, NULL, 0, corvus3_teleporteffect,
	FRAME_cinewalk2, ai_c_move, 4, 0, 0, NULL, 0, corvus3_visible,
	FRAME_cinewalk3, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk4, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk5, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk6, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk7, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk8, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk9, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk10, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk11, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk12, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk13, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk14, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk15, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk16, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk1, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk2, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk3, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_cinewalk4, ai_c_move, 4, 0, 0, NULL, 0, NULL,
};

animmove_t corvus3_move_c_walk3 = {20, corvus3_frames_c_walk3, ai_c_cycleend};

/*----------------------------------------------------------------------
  Corvus - starting his walk anims
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_walkstart [] =
{
	FRAME_gorun2, ai_c_move, 4, 0, 0, NULL, 0, NULL,
	FRAME_gorun3, ai_c_move, 4, 0, 0, NULL, 0, NULL,
};
animmove_t corvus3_move_c_walkstart = {2, corvus3_frames_c_walkstart, ai_c_cycleend};


/*----------------------------------------------------------------------
  Corvus - stopping his walk with right foot in front
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_walkstop1 [] =
{
	FRAME_jog1, ai_c_move, 2, 0, 0, NULL, 0, NULL,
	FRAME_jog2, ai_c_move, 2, 0, 0, NULL, 0, NULL,
};
animmove_t corvus3_move_c_walkstop1 = {2, corvus3_frames_c_walkstop1, ai_c_cycleend};

/*----------------------------------------------------------------------
  Corvus - stopping his walk with left foot in front
-----------------------------------------------------------------------*/
animframe_t corvus3_frames_c_walkstop2 [] =
{
	FRAME_jog5, ai_c_move, 2, 0, 0, NULL, 0, NULL,
	FRAME_jog6, ai_c_move, 2, 0, 0, NULL, 0, NULL,
};
animmove_t corvus3_move_c_walkstop2 = {2, corvus3_frames_c_walkstop2, ai_c_cycleend};

