//==============================================================================
//
// c_elflord_anim.c
//
// Heretic II
// Copyright 1998 Raven Software
//
//==============================================================================

#include "g_local.h"

#pragma hdrstop("g_local.pch")
// PRECOMPILED HEADER ABOVE
// WARNING:  DO NOT CHANGE THE ABOVE HEADERS OR THE PRECOMPILED STUFF WILL BREAK!  
// ADD ANY ADDITIONAL FILES BELOW

#include "c_elflord_anim.h"
#include "c_elflord.h"
#include "c_ai.h"

void Elflord_c_throwhead(edict_t *self);
void elflord_mist(edict_t *self, float x, float y, float z);

animframe_t Elflord_frames_c_death1 [] =
{
	FRAME_death1, ai_c_move, 0, 0, 0, NULL, 0, Elflord_c_throwhead,
	FRAME_death2, elflord_mist, 0, 0, 0, NULL, 0, NULL, 
	FRAME_death3, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_death4, elflord_mist, 0, 0, 0, NULL, 0, NULL, 
	FRAME_death5, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_death6, elflord_mist, 0, 0, 0, NULL, 0, NULL, 
	FRAME_death7, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_death8, elflord_mist, 0, 0, 0, NULL, 0, NULL, 
	FRAME_death9, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_death10, elflord_mist, 0, 0, 0, NULL, 0, NULL, 
	FRAME_death11, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_death12, elflord_mist, 0, 0, 0, NULL, 0, NULL, 
	FRAME_death13, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_death14, elflord_mist, 0, 0, 0, NULL, 0, NULL, 
	FRAME_death15, ai_c_move, 0, 0, 0, NULL, 0, NULL 
};
animmove_t Elflord_move_c_death1 = { 15, Elflord_frames_c_death1, ai_c_cycleend};


animframe_t Elflord_frames_c_death2 [] =
{
	FRAME_death1, elflord_mist,  0, 0, 0, NULL, 0, Elflord_c_boom, 
	FRAME_death2, ai_c_move, 0,  0, 0, NULL, 0, NULL, 
	FRAME_death3, elflord_mist,  0, 0, 0, NULL, 0, NULL, 
	FRAME_death4, ai_c_move, 0,  0, 0, NULL, 0, NULL, 
	FRAME_death5, elflord_mist,  0, 0, 0, NULL, 0, NULL, 
	FRAME_death6, ai_c_move, 0,  0, 0, NULL, 0, NULL, 
	FRAME_death7, elflord_mist,  0, 0, 0, NULL, 0, NULL, 
	FRAME_death8, ai_c_move, 0,  0, 0, NULL, 0, Elflord_c_boom, 
	FRAME_death9, elflord_mist,  0, 0, 0, NULL, 0, NULL, 
	FRAME_death10, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_death11, elflord_mist, 0, 0, 0, NULL, 0, NULL, 
	FRAME_death12, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_death13, elflord_mist, 0, 0, 0, NULL, 0, NULL, 
	FRAME_death14, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_death15, elflord_mist, 0, 0, 0, NULL, 0, NULL 
};
animmove_t Elflord_move_c_death2 = { 15, Elflord_frames_c_death2, ai_c_cycleend};

animframe_t Elflord_frames_c_idle1 [] =
{
	FRAME_idle1, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_idle2, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_idle3, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_idle4, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_idle5, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_idle6, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_idle7, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_idle8, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_idle9, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_idle10, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_idle11, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_idle12, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_idle13, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_idle14, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_idle15, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_idle16, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_idle17, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_idle18, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_idle19, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_idle20, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_idle21, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_idle22, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_idle23, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_idle24, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
};
animmove_t Elflord_move_c_idle1 = { 24, Elflord_frames_c_idle1, ai_c_cycleend};

animframe_t Elflord_frames_c_idle2 [] =
{
	FRAME_cidle1, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_cidle2, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_cidle3, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_cidle4, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_cidle5, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_cidle6, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_cidle7, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_cidle8, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_cidle9, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_cidle10, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_cidle11, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_cidle12, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_cidle13, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_cidle14, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_cidle15, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_cidle16, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_cidle17, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_cidle18, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_cidle19, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_cidle20, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
};
animmove_t Elflord_move_c_idle2 = { 20, Elflord_frames_c_idle2, ai_c_cycleend};


animframe_t Elflord_frames_c_action1 [] =
{
	FRAME_Dialoguea1, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea2, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea3, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea4, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea5, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea6, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea7, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea8, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea9, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea10, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialoguea11, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea12, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea13, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea14, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea15, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea16, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea17, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea18, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea19, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea20, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialoguea21, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea22, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea23, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea24, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea25, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea26, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea27, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea28, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea29, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea30, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialoguea31, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea32, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea33, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea34, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea35, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea36, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea37, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea38, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea39, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea40, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialoguea41, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea42, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea43, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea44, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea45, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea46, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea47, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea48, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea49, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea50, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialoguea51, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea52, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea53, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea54, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea55, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea56, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea57, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea58, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea59, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea60, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialoguea61, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea62, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea63, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea64, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea65, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea66, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea67, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea68, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea69, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea70, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialoguea71, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea72, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea73, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea74, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea75, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea76, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea77, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea78, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea79, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea80, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialoguea81, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea82, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea83, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea84, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea85, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea86, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea87, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea88, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea89, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea90, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialoguea91, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea92, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea93, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea94, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea95, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea96, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea97, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea98, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea99, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea100, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialoguea101, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea102, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea103, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea104, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea105, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea106, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea107, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea108, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea109, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea110, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialoguea111, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea112, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea113, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea114, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea115, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea116, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea117, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea118, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea119, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea120, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialoguea121, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea122, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea123, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea124, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea125, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea126, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea127, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea128, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea129, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea130, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialoguea131, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea132, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea133, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea134, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea135, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea136, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea137, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea138, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea139, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea140, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialoguea141, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea142, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea143, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea144, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea145, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea146, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea147, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea148, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea149, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea150, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialoguea151, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea152, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea153, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea154, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea155, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea156, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea157, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea158, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea159, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea160, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialoguea161, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea162, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea163, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea164, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea165, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea166, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea167, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea168, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea169, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea170, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialoguea171, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea172, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea173, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea174, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea175, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea176, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea177, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea178, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea179, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea180, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialoguea181, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea182, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea183, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea184, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea185, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea186, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea187, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea188, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea189, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea190, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialoguea191, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea192, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea193, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea194, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea195, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea196, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea197, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea198, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea199, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea200, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialoguea201, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea202, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea203, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea204, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea205, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea206, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea207, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea208, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea209, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea210, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialoguea211, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea212, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea213, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea214, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea215, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea216, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea217, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea218, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea219, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialoguea220, ai_c_move, 0, 0, 0, NULL, 0, NULL 
};
animmove_t Elflord_move_c_action1 = { 220, Elflord_frames_c_action1, ai_c_cycleend};


animframe_t Elflord_frames_c_action2 [] =
{
	FRAME_Dialogueb1, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb2, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb3, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb4, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb5, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb6, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb7, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb8, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb9, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb10, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialogueb11, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb12, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb13, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb14, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb15, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb16, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb17, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb18, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb19, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb20, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialogueb21, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb22, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb23, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb24, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb25, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb26, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb27, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb28, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb29, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb30, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialogueb31, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb32, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb33, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb34, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb35, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb36, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb37, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb38, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb39, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb40, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialogueb41, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb42, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb43, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb44, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb45, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb46, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb47, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb48, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb49, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb50, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialogueb51, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb52, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb53, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb54, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb55, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb56, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb57, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb58, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb59, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb60, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialogueb61, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb62, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb63, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb64, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb65, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb66, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb67, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb68, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb69, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb70, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialogueb71, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb72, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb73, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb74, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb75, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb76, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb77, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb78, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb79, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb80, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialogueb81, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb82, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb83, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb84, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb85, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb86, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb87, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb88, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb89, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb90, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialogueb91, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb92, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb93, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb94, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb95, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb96, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb97, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb98, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb99, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb100, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialogueb101, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb102, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb103, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb104, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb105, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb106, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb107, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb108, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb109, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb110, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialogueb111, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb112, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb113, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb114, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb115, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb116, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb117, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb118, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb119, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb120, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialogueb121, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb122, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb123, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb124, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb125, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb126, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb127, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb128, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb129, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb130, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialogueb131, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb132, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb133, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb134, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb135, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb136, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb137, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb138, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb139, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb140, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialogueb141, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb142, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb143, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb144, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb145, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb146, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb147, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb148, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb149, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb150, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialogueb151, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb152, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb153, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb154, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb155, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb156, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb157, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb158, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb159, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb160, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialogueb161, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb162, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb163, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb164, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb165, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb166, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb167, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb168, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb169, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb170, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialogueb171, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb172, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb173, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb174, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb175, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb176, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb177, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb178, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb179, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb180, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialogueb181, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb182, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb183, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb184, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb185, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb186, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb187, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb188, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb189, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb190, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialogueb191, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb192, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb193, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb194, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb195, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb196, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb197, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb198, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb199, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb200, ai_c_move, 0, 0, 0, NULL, 0, NULL, 

	FRAME_Dialogueb201, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb202, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb203, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb204, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb205, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
	FRAME_Dialogueb206, ai_c_move, 0, 0, 0, NULL, 0, NULL, 
};
animmove_t Elflord_move_c_action2 = { 206, Elflord_frames_c_action2, ai_c_cycleend};








