// ***************************************
// ** SHRINE STATS
// ***************************************

// duration of shrine light on player - in seconds
#define LIGHT_DURATION 90
// duration of shrine reflect on player - in seconds
#define REFLECT_DURATION_SINGLE 30
// duration of shrine reflect on player - in seconds
#define REFLECT_DURATION_DEATHMATCH 20
// duration of shrine ghosting on player - in seconds
#define GHOST_DURATION 60
// duration of shrine powerup on player weapons - in seconds
#define POWERUP_DURATION 30
// duration of shrine lungs on player - in seconds
#define LUNGS_DURATION 20
// time till Shrine is useable again if so toggled - in seconds
#define SHRINE_DELAY	45
// duration of shrine speed on player - in seconds
#define SPEED_DURATION 25

// amount of armor you get at a shrine - note support is in for gold armor - you just can't actually get it at this stage
#define MAX_GOLD_ARMOR		250		// amount of damage it can absorb
#define MAX_SILVER_ARMOR	100		// amount of damage it can absorb
#define	SILVER_HIT_MULT		0.5		// percentage of hit damage we take on a physical hit - silver armor
#define	SILVER_SPELL_MULT	0.5		// percentage of hit damage we take on a spell hit - silver armor
#define	GOLD_HIT_MULT		0.25	// percentage of hit damage we take on a physical hit - gold armor
#define	GOLD_SPELL_MULT		0.25	// percentage of hit damage we take on a spell hit - gold armor

#define SHRINE_HEALTH		100
#define SHRINE_MAX_HEALTH	150


// ***************************************
// ** MANA ITEM STATS
// ***************************************

#define HALF_OFF_MANA	20
#define FULL_OFF_MANA	40

#define HALF_DEF_MANA	20
#define FULL_DEF_MANA	40

#define HALF_COMBO_MANA	30
#define FULL_COMBO_MANA	30


// ***************************************
// ** SPELL ITEM STATS
// ***************************************

#define RESPAWN_TIME_WEAPON		30			// seconds
#define RESPAWN_TIME_MACEBALL	60			// seconds
#define RESPAWN_TIME_DEFENSE	30			// seconds
#define RESPAWN_TIME_RING		20			// seconds
#define RESPAWN_TIME_TELEPORT	25			// seconds
#define RESPAWN_TIME_MORPH		40			// seconds
#define RESPAWN_TIME_AMMO		20			// seconds
#define RESPAWN_TIME_ARROWS		30			// seconds
#define RESPAWN_TIME_MISC		20			// seconds


// Ammunition usage
#define AMMO_USE_FIREBALL		2
#define AMMO_USE_HELLSTAFF		1
#define AMMO_USE_MAGICMISSILE	3
#define AMMO_USE_REDRAIN		1
#define AMMO_USE_SPHERE			7
#define AMMO_USE_PHOENIX		1
#define AMMO_USE_MACEBALL		12
#define AMMO_USE_FIREWALL		5

#define MANA_USE_POWERUP		60
#define MANA_USE_RING			5
#define MANA_USE_SHIELD			20
#define MANA_USE_TELEPORT		15
#define MANA_USE_POLYMORPH		30
#define MANA_USE_METEORS		5			// Five PER meteor:  Total of 20
#define MANA_USE_TORNADO		30



#define AMMO_COUNT_MOST			20
#define AMMO_COUNT_REDRAINBOW	5
#define AMMO_COUNT_PHOENIXBOW	5
#define AMMO_COUNT_HELLSTAFF	50


#define MAX_OFF_MANA			100
#define MAX_DEF_MANA			100
#define MAX_RAIN_AMMO			30
#define MAX_PHOENIX_AMMO		20
#define MAX_HELL_AMMO			200

